#set_verify_elf_method relaxed

%define xulr_name			xulrunner
%define xulr_version			1.9.0.9
%define xulr_fullname			%xulr_name-%xulr_version

%define xulr_prefix			%_libdir/%xulr_name
%define xulr_datadir			%_datadir/%xulr_name

%define xulr_arch_extensionsdir		%xulr_prefix/extensions
%define xulr_noarch_extensionsdir	%xulr_datadir/extensions
%define xulr_extensionsdir		%xulr_arch_extensionsdir

%define xulr_sysconfdir			%_sysconfdir/mozilla
%define xulr_bindir			%_libdir/%xulr_name
%define xulr_libdir			%_libdir/%xulr_name
%define xulr_idldir			%_datadir/idl/%xulr_name
%define xulr_includedir			%_includedir/%xulr_name

%define xulr_exec			%_bindir/xulrunner
%define xulr_bin			%xulr_bindir/xulrunner-bin
%define xulr_run			%xulr_bindir/run-mozilla.sh

%define xulr_develdir			%_libdir/%xulr_name-devel

%define xulr_devel_bindir		%xulr_develdir/bin
%define xulr_devel_libdir		%xulr_develdir/lib
%define xulr_devel_idldir		%xulr_develdir/idl
%define xulr_devel_includedir		%xulr_develdir/include
%define xulr_xpcom_config_h		%xulr_develdir/xpcom-config.h

%define xulr_sdkdir			%xulr_develdir/sdk
%define xulr_sdk_libdir			%xulr_sdkdir/lib
%define xulr_sdk_idldir			%xulr_sdkdir/idl
%define xulr_sdk_includedir		%xulr_sdkdir/include

%def_without	debug
%def_with	svg
%def_with	sqlite
%def_with	libxul
%def_without	mozldap
%def_with	gnome
%def_with	xpcom_python
%def_with	hunspell

Summary:	XUL Runner
Name:		%xulr_name
Version:	%xulr_version
Release:	alt0.M41.1
License:	MPL/GPL/LGPL
Group:		Networking/Other
Url:		http://wiki.mozilla.org/XUL:Xul_Runner
Packager:	Valery Inozemtsev <shrek@altlinux.ru>

Source0:	xulrunner-source.tar
Source1:	update-sdk.sh

Patch1:		firefox3-alt-prefs-changes.patch
Patch2:		firefox-1.5.0.1-alt-asm-directive.patch
Patch3:		xulrunner-alt-devel-path-fix.patch
Patch4:		xulrunner19-alt-extensions-dir.patch
Patch5:		mozilla-firefox-1.0-lib64.patch
Patch6:		xulrunner19-with-system-mozldap.patch
Patch7:		xulrunner-symbols-fix.patch
Patch8:		firefox3-alt-disable-werror.patch
Patch9:		firefox3-alt-rpath-link.patch
Patch10:	xulrunner-fix-prefs.patch
Patch11:	xulrunner-simplify-startup.patch
Patch12:	xulrunner-fix-hunspell-links.patch
Patch13:	xulrunner-pc-libdir.patch
#Patch14:	xulrunner-alt-fix-crashreporter.patch

Patch101:	456541.patch
Patch102:	358926.patch

# Ubuntu patches
Patch201:	add_syspref_dir.patch
Patch202:	jemalloc_in_xul.patch
Patch203:	mozilla-ps-pdf-simplify-operators.patch
Patch204:	bz412610_att335369_realpath_overflow.patch
Patch205:	bzXXX_no_zlib_export_if_native.patch
Patch206:	bzXXX_plugin_for_mimetype_pref.patch

Requires: hunspell-en
Requires: xulrunner-libs = %version-%release

BuildRequires(pre): rpm-build-mozilla.org

# Automatically added by buildreq on Fri Feb 08 2008
BuildRequires: bzlib-devel doxygen gcc-c++ imake libIDL-devel libXt-devel libXext-devel libXft-devel
BuildRequires: libcurl-devel libdbus-glib-devel libgtk+2-devel libhunspell-devel libjpeg-devel
BuildRequires: liblcms-devel libnss-devel-static libsqlite3-devel-static makedepend nss-utils
BuildRequires: unzip xorg-cf-files zip chrpath alternatives
BuildRequires: libshell

BuildRequires: autoconf_2.13
%set_autoconf_version 2.13

%description
XULRunner is a single "gecko runtime" installable package
that can be used to bootstrap multiple XUL+XPCOM applications

%package libs
Summary:	XULRunner libraries.
Group:		System/Libraries

%description libs
XULRunner  libraries.

%package devel
Summary:	XULRunner development kit.
Group:		Development/C++

Requires:	xulrunner = %version-%release
Obsoletes:	firefox-devel
Provides:	firefox-devel >= 3.0
Conflicts:	seamonkey-devel

%description devel
XULRunner development kit.

%if_with gnome
%package gnome-support
Summary:	XULRunner development kit.
Group:		Development/Other
Requires:	xulrunner = %version-%release
BuildRequires:	gnome-vfs-devel libgnomeui-devel libgnome-devel

%description gnome-support
GNOME support in XULRunner.
%endif

%if_with xpcom_python
%package -n python-module-xpcom
Summary:	XPCOM bindings for Python
Group:		Development/Python
Requires:	xulrunner = %version-%release
BuildRequires:	python-dev python-modules-compiler

%description -n python-module-xpcom
PyXPCOM allows for communication between Python and XPCOM, such that
a Python application can access XPCOM objects, and XPCOM can access
any Python class that implements an XPCOM interface.
With PyXPCOM, a developer can talk to XPCOM or embed Gecko from
a Python application.
%endif

%prep
%setup -q -c -n %xulr_fullname
cd %_builddir/%xulr_fullname/mozilla

%patch1 -p1 -b .fix1
%patch2 -p1 -b .fix2
%patch3 -p1 -b .fix3
%patch4 -p1 -b .fix4
%patch5 -p1 -b .fix5
%patch6 -p2 -b .fix6
%patch7 -p1 -b .fix7
%patch8 -p1 -b .fix8
%patch9 -p1 -b .fix9
#patch10 -p1 -b .fix10
%patch11 -p1 -b .fix11
%patch12 -p1 -b .fix12
%patch13 -p1 -b .fix13
#patch14 -p1 -b .fix14

%patch101 -p1 -b .fix101
%patch102 -p1 -b .fix102

#patch201 -p1 -b .fix201
%patch202 -p1 -b .fix202
%patch203 -p1 -b .fix203
%patch204 -p1 -b .fix204
%patch205 -p1 -b .fix205
%patch206 -p1 -b .fix206

%build
cd %_builddir/%xulr_fullname/mozilla

%add_optflags %optflags_shared

%__subst 's#AC_CONFIG_AUX_DIR(\${srcdir}/build/autoconf)#AC_CONFIG_AUX_DIR(build/autoconf)#' configure.in
%__subst 's/^SQLITE_VERSION=.*/SQLITE_VERSION=3.5.9/' configure.in
%__autoconf

export LIBIDL_CONFIG=/usr/bin/libIDL-config-2

%configure \
	--includedir=%_includedir \
	--disable-activex \
	--disable-activex-scripting \
	--disable-tests \
	--disable-installer \
	--disable-updater \
	--disable-crashreporter \
	--disable-mochitest \
	--disable-freetype2 \
	--disable-javaxpcom \
	--disable-elf-dynstr-gc \
	--enable-xft \
	--enable-crypto \
	--enable-application=xulrunner \
	--enable-optimize="-O2" \
	--enable-default-toolkit=cairo-gtk2 \
	--enable-canvas \
	--enable-safe-browsing \
	--enable-url-classifier \
	--enable-jemalloc \
	--enable-oji \
%if_with debug
	--disable-strip \
	--enable-debug \
	--enable-debug-modules \
	--enable-logrefcnt \
	--enable-debugger-info-modules \
	--enable-detect-webshell-leaks \
%else
	--enable-strip \
	--enable-install-strip \
	--disable-debug \
%endif # debug
%if_with svg
	--enable-svg \
  	--enable-svg-renderer-cairo \
%endif # svg
%if_with libxul
	--enable-libxul \
%endif # libxul
%if_with sqlite
	--enable-system-sqlite \
%endif # sqlite
%if_with mozldap
	--enable-ldap \
	--with-system-mozldap \
%endif # mozldap
%if_with hunspell
	--enable-system-hunspell \
%endif # hunspell
%if_with xpcom_python
	--enable-extensions="default,python/xpcom" \
%endif # xpcom_python
	\
	--without-system-png \
	\
	--enable-places \
	--enable-storage \
	--enable-system-lcms \
	--enable-system-cairo \
	--with-system-nspr \
	--with-system-nss \
	--with-system-jpeg \
	--with-system-zlib \
	--with-system-bz2 \
	--with-pthreads \
	#

%make_build \
	mozappdir=%xulr_prefix \
	#

%install
cd %_builddir/%xulr_fullname/mozilla
%__mkdir_p \
	%buildroot/%xulr_arch_extensionsdir \
	%buildroot/%xulr_noarch_extensionsdir \
	%buildroot%python_sitelibdir \
	#

%makeinstall \
	idldir=%buildroot/%xulr_idldir \
	includedir=%buildroot/%xulr_includedir \
	mozappdir=%buildroot/%xulr_prefix \
	#

%SOURCE1 \
	--develdir="%buildroot/%xulr_prefix-devel" \
	--bindir="%buildroot/%_bindir" \
	--libdir="%buildroot/%xulr_libdir" \
	--idldir="%buildroot/%xulr_idldir" \
	--includedir="%buildroot/%xulr_includedir" \
        --rpath="" \
        #

cd %buildroot
rm -f -- \
	./%xulr_prefix/run-mozilla.sh \
	./%xulr_prefix/LICENSE \
	./%xulr_prefix/README.txt \
	./%xulr_prefix/dictionaries/* \
	#

ln -s %_datadir/myspell/en_US.aff %buildroot/%xulr_prefix/dictionaries/en-US.aff
ln -s %_datadir/myspell/en_US.dic %buildroot/%xulr_prefix/dictionaries/en-US.dic

mkdir -p -- ./%xulr_sysconfdir/%name/default
mv -f -- ./%xulr_prefix/defaults ./%xulr_sysconfdir/%name/default/
ln -s -- default ./%xulr_sysconfdir/%name/current
ln -s -- %xulr_sysconfdir/%name/current/defaults ./%xulr_prefix/defaults

mv -f -- ./%xulr_prefix/python/xpcom ./%python_sitelibdir
rm -rf -- ./%xulr_prefix/python

# Add alternatives
mkdir -p -- ./%_altdir
printf '%xulr_sysconfdir/%name/current\t%xulr_sysconfdir/%name/default\t1\n' >./%_altdir/%name-settings

sed -i -e "s#^GRE_PATH=%{buildroot}#GRE_PATH=#" ./%_sysconfdir/gre.d/*.conf
chmod 644 ./%_sysconfdir/gre.d/*.conf

sed -i -e 's#%{buildroot}##g' ./%_libdir/pkgconfig/*.pc

for l in libjemalloc.so libmozjs.so libxpcom.so libxul.so libpyxpcom.so; do
	[ -f .%xulr_libdir/$l ] ||
		continue
	mv -f -- .%xulr_libdir/$l .%_libdir/$l
	ln -s -- %_libdir/$l  .%xulr_libdir/$l
done

# Move jsapi.h to proper place (#17561)
[ ! -f ./%xulr_includedir/unstable/jsapi.h ] ||
	mv -f \
		./%xulr_includedir/unstable/jsapi.h \
		./%xulr_includedir/stable/jsapi.h

%pre
f="%_libdir/xulrunner"
[ ! -L "$f" ] || rm -f -- "$f"
f="%_libdir/xulrunner-1.8.1.10"
[ ! -d "$f" ] || rm -rf -- "$f"

%post
%register_alternatives %name-settings

%preun
[ $1 = 0 ] || exit 0
%unregister_alternatives %name-settings

%files
%_sysconfdir/gre.d
%xulr_sysconfdir
%exclude %xulr_sysconfdir/%name/current
%_altdir/%name-settings
%_bindir/%name
%_libdir/%name
%exclude %xulr_prefix/xpcshell
%exclude %xulr_prefix/xpidl
%exclude %xulr_prefix/xpt_dump
%exclude %xulr_prefix/xpt_link
%if_with xpcom_python
%exclude %xulr_libdir/libpyxpcom.so
%exclude %xulr_libdir/components/libpyloader.so
%exclude %xulr_libdir/components/pyabout.py*
%endif
%if_with gnome
%exclude %xulr_libdir/components/libnkgnomevfs.so
%exclude %xulr_libdir/components/libmozgnome.so
%endif

%if_with gnome
%files gnome-support
%xulr_libdir/components/libnkgnomevfs.so
%xulr_libdir/components/libmozgnome.so
%endif

%files libs
%_libdir/*.so*
%if_with xpcom_python
%exclude %_libdir/libpyxpcom.so*
%endif

%files devel
%_libdir/pkgconfig/*
%xulr_prefix/xpcshell
%xulr_prefix/xpidl
%xulr_prefix/xpt_dump
%xulr_prefix/xpt_link
%xulr_includedir
%xulr_develdir
%xulr_idldir

%if_with xpcom_python
%files -n python-module-xpcom
%_libdir/libpyxpcom.so*
%xulr_libdir/libpyxpcom.so
%xulr_libdir/components/libpyloader.so
%xulr_libdir/components/pyabout.py*
%python_sitelibdir/xpcom
%endif

%changelog
* Thu Apr 23 2009 Valery Inozemtsev <shrek@altlinux.ru> 1.9.0.9-alt0.M41.1
- build for branch 4.1

* Thu Apr 23 2009 Valery Inozemtsev <shrek@altlinux.ru> 1.9.0.9-alt1.M50.1
- 1.9.0.9

* Thu Apr 02 2009 Valery Inozemtsev <shrek@altlinux.ru> 1.9.0.7-alt0.M41.1
- build for branch 4.1

* Thu Apr 02 2009 Valery Inozemtsev <shrek@altlinux.ru> 1.9.0.7-alt1.M50.1
- 1.9.0.7

* Mon Dec 08 2008 Alexey Gladkov <legion@altlinux.ru> 1.9.0.5-alt1.20081205
- Bugfix build.
- Add patch for moz#358926 (closes: #18085).

* Tue Nov 18 2008 Alexey Gladkov <legion@altlinux.ru> 1.9.0.5-alt1.20081118
- Bugfix build up to firefox-3.0.4.
- Add confilct with seamonkey-devel (closes: #17682).
- Move jsapi.h to stable directory (closes: #17561).
- Fixed:
  + MFSA 2008-58 Parsing error in E4X default namespace
  + MFSA 2008-57 -moz-binding property bypasses security checks on codebase principals
  + MFSA 2008-56 nsXMLHttpRequest::NotifyEventListeners() same-origin violation
  + MFSA 2008-55 Crash and remote code execution in nsFrameManager
  + MFSA 2008-54 Buffer overflow in http-index-format parser
  + MFSA 2008-53 XSS and JavaScript privilege escalation via session restore
  + MFSA 2008-52 Crashes with evidence of memory corruption (rv:1.9.0.4/1.8.1.18)
  + MFSA 2008-51 file: URIs inherit chrome privileges when opened from chrome
  + MFSA 2008-47 Information stealing via local shortcut files

* Mon Oct 06 2008 Alexey Gladkov <legion@altlinux.ru> 1.9.0.3-alt1.20081005
- Bugfix build up to firefox-3.0.3.
- Add python-module-xpcom subpackage.
- Firefox does not participate in accessibility on 64 bit Linux (moz#456541).
- Printing on linux should set SIMPLIFY_OPERATORS | DISABLE_SNAPPING (moz#435313).
- MAXPATHLEN too small for glibc's realpath() (moz#412610).
- New preference that allows users to set a preferred plugin
  for a given mime-type.
- Fixed:
  + MFSA 2008-44 resource: traversal vulnerabilities
  + MFSA 2008-43 BOM characters stripped from JavaScript before execution
  + MFSA 2008-42 Crashes with evidence of memory corruption (rv:1.9.0.2/1.8.1.17)
  + MFSA 2008-41 Privilege escalation via XPCnativeWrapper pollution
  + MFSA 2008-40 Forced mouse drag

* Mon Sep 08 2008 Alexey Gladkov <legion@altlinux.ru> 1.9.0.3-alt1.20080908
- Bugfix build.
- Fix BuildRequires.
- Rebuild with hunspell-1.2.7-alt1.
- Add libdir variable into *.pc (ALT#16634).
- Fix #13786.

* Fri Jul 18 2008 Alexey Gladkov <legion@altlinux.ru> 1.9-alt2.20080718
- Bugfix build up to firefox-3.0.1.
- Fixed:
  + MFSA 2008-36 Crash with malformed GIF file on Mac OS X
  + MFSA 2008-35 Command-line URLs launch multiple tabs when Firefox not running
  + MFSA 2008-34 Remote code execution by overflowing CSS reference counter

* Fri Jul 11 2008 Alexey Gladkov <legion@altlinux.ru> 1.9-alt2.20080704
- Bugfix build.
- Tune default settings.
- Stop double instantiation even earlier (BMO#438830).
- Build with --enable-oji (BMO#445063).
- Move libjemalloc.so libmozjs.so libxpcom.so libxul.so into %%_libdir
  and remove RPATH and LD_LIBRARY_PATH.
- Use hunspell-en dictionary.

* Fri Jul 04 2008 Alexey Gladkov <legion@altlinux.ru> 1.9-alt1.20080704
- New cvs snapshot.
- Dont use NetworkManager by default (BMO#424626).
- Allow change default settings.

* Thu Jun 05 2008 Alexey Gladkov <legion@altlinux.ru> 1.9-alt1.20080605
- New cvs snapshot.
- Add new sub-package: xulrunner-gnome-support.

* Thu May 29 2008 Alexey Gladkov <legion@altlinux.ru> 1.9-alt1.20080529
- New cvs snapshot.

* Sun Feb 03 2008 Alexey Gladkov <legion@altlinux.ru> 1.9-alt1.b3pre
- New cvs snapshot.
- Add SDK toolkit.

* Wed Nov 21 2007 Alexey Gladkov <legion@altlinux.ru> 1.8.1.10-alt1
- Build from cvs.

* Fri Sep 28 2007 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt5
- Fix buildrequires;

* Tue Feb 27 2007 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt4
- Remove requires nspr with version from *.pc

* Thu Oct 19 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt3
- Add cookie and permissions extensions.

* Fri Sep 22 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt2
- Fix Cflags in *.pc

* Wed Aug 30 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.4-alt1
- New version (1.8.0.4-alt1).
- Update BuildRequires.

* Thu Jul 06 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.1-alt2
- fixed build system.

* Sat Mar 25 2006 Alexey Gladkov <legion@altlinux.ru> 1.8.0.1-alt1
- new version.
- Build with system NSS and NSPR.
- Build libxul.
- Header bugfix.
- Directory /usr/share/xulrunner-@version@/extensions was added to extensions search path .
  * this location is controled by the option extensions.dir.extensions .

* Thu Jun 16 2005 Alexey Gladkov <legion@altlinux.ru> 0.0.0-alt1
- first build for ALT Linux.
